routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth/login');
});

Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');
Auth::routes();

Route::get('/home', 'App\Http\Controllers\HomeController@index')->name('home')->middleware('auth');

Route::group(['middleware' => 'auth'], function () {
	Route::get('table-list', function () {
		return view('pages.table_list');
	})->name('table');

	Route::get('typography', function () {
		return view('pages.typography');
	})->name('typography');

	Route::get('icons', function () {
		return view('pages.icons');
	})->name('icons');

	Route::get('map', function () {
		return view('pages.map');
	})->name('map');

	Route::get('notifications', function () {
		return view('pages.notifications');
	})->name('notifications');

	Route::get('rtl-support', function () {
		return view('pages.language');
	})->name('language');

	Route::get('upgrade', function () {
		return view('pages.upgrade');
	})->name('upgrade');
});

Route::group(['middleware' => 'auth'], function () {
	
	Route::group(['middleware' => ['permission:config']], function () {
		Route::resource('user', 'App\Http\Controllers\UserController', ['except' => ['show']]);
    });	
	
	Route::get('profile', ['as' => 'profile.edit', 'uses' => 'App\Http\Controllers\ProfileController@edit']);
	Route::put('profile', ['as' => 'profile.update', 'uses' => 'App\Http\Controllers\ProfileController@update']);
	Route::put('profile/password', ['as' => 'profile.password', 'uses' => 'App\Http\Controllers\ProfileController@password']);
});

app/Models/User.php
<?php

namespace App\Models;

use Carbon\Carbon;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Illuminate\Support\Facades\Auth;
use Spatie\Permission\Models\Permission;
use Spatie\MediaLibrary\InteractsWithMedia;
use Spatie\MediaLibrary\Models\Media;
use Spatie\Image\Manipulations;
use Spatie\MediaLibrary\HasMedia\HasMedia;
use Spatie\MediaLibrary\HasMedia\HasMediaTrait;
use Spatie\Permission\Traits\HasRoles;


class User extends Authenticatable implements HasMedia
{
    use HasFactory, Notifiable, SoftDeletes, HasRoles;
    use HasMediaTrait {
        getFirstMediaUrl as protected getFirstMediaUrlTrait;
    }


    protected $dates = ['deleted_at'];

    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [
        'name' => 'required|string|max:255',
        'email' => 'required|string|email|max:255|unique:users',
    ];

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'name' => 'string',
        'email' => 'string',
        'password' => 'string',
        'email_verified_at' => 'datetime',
    ];

    /**
     * New Attributes
     *
     * @var array
     */
    protected $appends = [
        'has_media'
    ];

    /**
     * Forma Date Human
     */
    public function getUpdatedAtAttribute ($value) {
        return Carbon::createFromTimeStamp(strtotime($value))->diffForHumans();
    }

    /**
     * @param Media|null $media
     * @throws \Spatie\Image\Exceptions\InvalidManipulation
     */
    public function registerMediaConversions($media = null)
    {
        $this->addMediaConversion('thumb')
            ->fit(Manipulations::FIT_CROP, 200, 200)
            ->sharpen(10);

        $this->addMediaConversion('icon')
            ->fit(Manipulations::FIT_CROP, 100, 100)
            ->sharpen(10);
    }

    /**
     * to generate media url in case of fallback will
     * return the file type icon
     * @param string $conversion
     * @return string url
     */
    public function getFirstMediaUrl($collectionName = 'default', $conversion = '')
    {
        $url = $this->getFirstMediaUrlTrait($collectionName);

        if ($url) {
            $array = explode('.', $url);
            // dd(config('medialibrary.extensions_has_thumb'));
            $extension = strtolower(end($array));
            if (in_array($extension, config('medialibrary.extensions_has_thumb'))) {
                return asset($this->getFirstMediaUrlTrait($collectionName, $conversion));
            } else {
                return asset(config('medialibrary.icons_folder') . '/' . $extension . '.png');
            }
        }else{
            return asset('avatar/default.png');
        }
    }


    /**
     * Add Media to api results
     * @return bool
     */
    public function getHasMediaAttribute()
    {
        return $this->hasMedia('avatar') ? true : false;
    }

    public function getAllPermissionsAttribute() {
        $permissions = [];
          foreach (Permission::all() as $permission) {
            if (Auth::user()->can($permission->name)) {
              $permissions[] = $permission->name;
            }
          }
          return $permissions;
      }
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\UpdateUserRequest;
use App\Models\User;
use App\Http\Requests\UserRequest;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Session;
use Spatie\Permission\Models\Role;

class UserController extends Controller
{
    /**
     * Display a listing of the users
     *
     * @param  \App\Models\User  $model
     * @return \Illuminate\View\View
     */
    //public function index(User $model)
    public function index(Request $request)
    {
        $search = trim($request->get('searchText'));
        $users = User::with('roles')->withTrashed()->where('name', 'LIKE', '%' . $search . '%')
            ->orWhere('email', 'LIKE', '%' . $search . '%')
            ->orderBy('id', 'DESC')
            ->paginate(10);
        return view('users.index', ['users' => $users, 'searchText' => $search]);
    }

    public function store(UserRequest $request)
    {
        $input = $request->all();
        $input['password'] = Hash::make($input['password']);
        $user = User::create($input);
        if (isset($input['avatar']) && $input['avatar']) {
            $user->addMediaFromRequest('avatar')->toMediaCollection('avatars');
        }
        $user->assignRole($input['role']);
        Session::flash('status', 'Usuario creado correctamente');
        return redirect('user');
    }

    public function create()
    {
        $roles = Role::all()->pluck('name', 'name');
        return view('users.add', ['roles' => $roles]);
    }

    public function edit($id)
    {
        $user = User::find($id);
        $roles = Role::all()->pluck('name');
        $rolesSelected = $user->roles()->pluck('name')->toArray();
        return view('users.edit', ['user' => $user, 'roles' => $roles, 'rolesSelected' => $rolesSelected]);
    }

    public function update(UpdateUserRequest $request, $id)
    {
        $user = User::find($id);
        // return response()->json($user);
        $input = $request->all();
        if (empty($input['password'])) {
            unset($input['password']);
        } else {
            $input['password'] = Hash::make($input['password']);
        }
        $user->update($input);

        if (isset($input['avatar']) && $request['avatar']) {
            $user->clearMediaCollection('avatars');
            $user->addMediaFromRequest('avatar')->toMediaCollection('avatars');
        }

        //Remove
        //DB::table('model_has_roles')->where('model_id',$id)->delete();
        $user->syncRoles($input['role']);

        if (auth()->user()->id == $id) {
            if (!empty($input['password'])) {
                Auth::logout();
                redirect('/');
            }
        }
        Session::flash('status', 'Usuario actualizado correctamente!');
        return redirect('user');
    }

    public function destroy($id)
    {
        $user = User::withTrashed()->where('id', $id)->first();
        if (empty($user)) {
            Session::flash('status', 'Usuario no encontrado');
            return redirect(route('user.index'));
        }

        if (empty($user->deleted_at)) {
            $user->delete($id);
            Session::flash('status', 'Usuario bloqueado correctamente');
        } else {
            $user->restore();
            Session::flash('status', 'Usuario activado correctamente');
        }

        return redirect(route('user.index'));
    }
}

resources/views/users/add.blade.php
@extends('layouts.app', ['activePage' => 'user', 'titlePage' => 'Agregar usuario'])

@section('css')
<link href="{{asset('material/css/material-pro.css')}}" rel="stylesheet">
@endsection
@section('content')

<div class="content">
    <div class="container-fluid">
        <div class="row">
            <div class="col-md-12">
                <form method="post" action="{{route('user.store')}}" autocomplete="off" class="form-horizontal " enctype="multipart/form-data">
                    @csrf
                    <div class="card ">
                        <div class="card-header card-header-primary">
                            <p class="card-category">Informacion del usuario</p>
                        </div>
                        <div class="card-body ">
                            @if (session('status'))
                            <div class="row">
                                <div class="col-sm-12">
                                    <div class="alert alert-success">
                                        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                            <i class="material-icons">close</i>
                                        </button>
                                        <span>{{ session('status') }}</span>
                                    </div>
                                </div>
                            </div>
                            @endif
                            <div class="row">
                                <div class="col-md-8 col-xs-12">
                                    <div class="col-xs-12">
                                        <div class="row">
                                            <label class="col-sm-2 col-form-label">Nombre</label>
                                            <div class="col-sm-7">
                                                <div class="form-group{{ $errors->has('name') ? ' has-danger' : '' }}">
                                                    <input class="form-control{{ $errors->has('name') ? ' is-invalid' : '' }}" name="name" id="input-name" type="text" placeholder="Nombre" value="{{ old('name') }}" required="true" aria-required="true" />
                                                    @if ($errors->has('name'))
                                                    <span id="name-error" class="error text-danger" for="input-name">{{ $errors->first('name') }}</span>
                                                    @endif
                                                </div>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <label class="col-sm-2 col-form-label">Correo</label>
                                            <div class="col-sm-7">
                                                <div class="form-group{{ $errors->has('email') ? ' has-danger' : '' }}">
                                                    <input class="form-control{{ $errors->has('email') ? ' is-invalid' : '' }}" name="email" id="input-email" type="email" placeholder="Correo" value="{{ old('email') }}" required />
                                                    @if ($errors->has('email'))
                                                    <span id="email-error" class="error text-danger" for="input-email">{{ $errors->first('email') }}</span>
                                                    @endif
                                                </div>
                                            </div>
                                        </div>
                                        <div class="row">                                            
                                            <label class="col-sm-2 col-form-label">Rol</label>
                                            <div class="col-md-7">
                                                <div class="dropdown bootstrap-select col-sm-12 pl-0 pr-0">
                                                    <select class="selectpicker col-sm-12 pl-0 pr-0" name="role" id="role" data-style="select-with-transition" title="" data-size="100" tabindex="-98" required>
                                                        @foreach($roles as $key => $role)
                                                            <option selected="Cliente" value="{{$role}}">{{$role}}</option>
                                                        @endforeach
                                                    </select>                                                    
                                                </div>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <label class="col-sm-2 col-form-label">Contraseña</label>
                                            <div class="col-sm-7">
                                                <div class="form-group{{ $errors->has('password') ? ' has-danger' : '' }}">
                                                    <input class="form-control{{ $errors->has('password') ? ' is-invalid' : '' }}" name="password" id="input-password" type="password" placeholder="Contraseña" value="" required />
                                                    @if ($errors->has('password'))
                                                    <span id="password-error" class="error text-danger" for="input-password">{{ $errors->first('password') }}</span>
                                                    @endif
                                                </div>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <label class="col-sm-2 col-form-label">Confirmar contraseña</label>
                                            <div class="col-sm-7">
                                                <div class="form-group{{ $errors->has('password_confirmation') ? ' has-danger' : '' }}">
                                                    <input class="form-control{{ $errors->has('password_confirmation') ? ' is-invalid' : '' }}" name="password_confirmation" id="password_confirmation" type="password" placeholder="Confirmar contraseña" value="" required />
                                                    @if ($errors->has('password_confirmation'))
                                                    <span id="password_confirmation-error" class="error text-danger" for="password_confirmation">{{ $errors->first('password_confirmation') }}</span>
                                                    @endif
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-md-4 col-xs-12">
                                    <div class="form-group form-file-upload form-file-multiple">
                                        <input type="file" name="avatar" id="avatar" accept="image/*" class="inputFileHidden file">
                                        <div class="input-group">
                                            <input id="file" type="text" class="form-control inputFileVisible" placeholder="Cargar imagen">
                                            <span class="input-group-btn">
                                                <button type="button" class="browse btn btn-fab btn-round btn-primary">
                                                    <i class="material-icons">attach_file</i>
                                                </button>
                                            </span>
                                        </div>
                                        <img src="{{asset('avatar/default.png')}}" id="preview" class="img-thumbnail">
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="card-footer ml-auto mr-auto">
                            <a class="btn btn-danger float-right_" href="{{route('user.index')}}">Volver a la lista</a>
                            <button type="submit" class="btn btn-primary">Guardar</button>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>
@endsection
@section('scripts')

@endsection

resources/views/users/edit.blade.php
@extends('layouts.app', ['activePage' => 'profile', 'titlePage' => 'Editar usuario'])

@section('css')
<link href="{{asset('material/css/material-pro.css')}}" rel="stylesheet">
@endsection
@section('content')
<div class="content">
    <div class="container-fluid">
        <div class="row">
            <div class="col-md-12">
                <form method="post" action="{{route('user.update', $user->id)}}" autocomplete="off" enctype="multipart/form-data" class="form-horizontal">
                    @csrf
                    @method('put')
                    <div class="card ">
                        <div class="card-header card-header-primary">
                            <p class="card-category">Informacion del usuario: {{$user->name}}</p>
                        </div>
                        <div class="card-body ">
                            @if (session('status'))
                            <div class="row">
                                <div class="col-sm-12">
                                    <div class="alert alert-success">
                                        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                            <i class="material-icons">close</i>
                                        </button>
                                        <span>{{ session('status') }}</span>
                                    </div>
                                </div>
                            </div>
                            @endif
                            <div class="row">
                                <div class="col-md-8 col-xs-12">
                                    <div class="col-xs-12">
                                        <div class="row">
                                            <label class="col-sm-2 col-form-label">Nombre</label>
                                            <div class="col-sm-7">
                                                <div class="form-group{{ $errors->has('name') ? ' has-danger' : '' }}">
                                                    <input class="form-control{{ $errors->has('name') ? ' is-invalid' : '' }}" name="name" id="input-name" type="text" placeholder="Nombre" value="{{ $user->name }}" required="true" aria-required="true" />
                                                    @if ($errors->has('name'))
                                                    <span id="name-error" class="error text-danger" for="input-name">{{ $errors->first('name') }}</span>
                                                    @endif
                                                </div>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <label class="col-sm-2 col-form-label">Correo</label>
                                            <div class="col-sm-7">
                                                <div class="form-group{{ $errors->has('email') ? ' has-danger' : '' }}">
                                                    <input class="form-control{{ $errors->has('email') ? ' is-invalid' : '' }}" name="email" id="input-email" type="email" placeholder="Correo" value="{{ $user->email }}" required />
                                                    @if ($errors->has('email'))
                                                    <span id="email-error" class="error text-danger" for="input-email">{{ $errors->first('email') }}</span>
                                                    @endif
                                                </div>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <label class="col-sm-2 col-form-label">Rol</label>
                                            <div class="col-md-7">
                                                <div class="dropdown bootstrap-select col-sm-12 pl-0 pr-0">
                                                    <select class="selectpicker col-sm-12 pl-0 pr-0" name="role" id="role" data-style="select-with-transition" title="" data-size="100" tabindex="-98">
                                                        @foreach($roles as $key => $role)
                                                            <option {{($rolesSelected[0] == $role) ? 'selected' : ''}} value="{{$role}}">{{$role}}</option>
                                                        @endforeach
                                                    </select>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <label class="col-sm-2 col-form-label" for="input-current-password">Contraseña actual</label>
                                            <div class="col-sm-7">
                                                <div class="form-group{{ $errors->has('password') ? ' has-danger' : '' }}">
                                                    <input class="form-control{{ $errors->has('password') ? ' is-invalid' : '' }}" input type="password" name="password" id="input-current-password" placeholder="Contraseña actual" value="" />
                                                    @if ($errors->has('password'))
                                                    <span id="name-error" class="error text-danger" for="input-name">{{ $errors->first('password') }}</span>
                                                    @endif
                                                </div>
                                                <p class="text-danger">
                                                    La contraseña se modifica si se escribe algo </p>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-md-4 col-md-2">
                                    <div class="form-group form-file-upload form-file-multiple">
                                        <input type="file" name="avatar" id="avatar" accept="image/*" class="inputFileHidden file">
                                        <div class="input-group">
                                            <input id="file" type="text" class="form-control inputFileVisible" placeholder="Cargar imagen">
                                            <span class="input-group-btn">
                                                <button type="button" class="browse btn btn-fab btn-round btn-primary">
                                                    <i class="material-icons">attach_file</i>
                                                </button>
                                            </span>
                                        </div>
                                        <img id="preview" class="img-thumbnail" src="{{$user->getFirstMediaUrl('avatars', 'thumb')}}" alt="{{$user->name}}">
                                        <!-- <img src="{{asset('storage/avatar/default.png')}}" id="preview" class="img-thumbnail"> -->
                                        <!-- <img src="{{asset('avatar/default.png')}}" id="preview" class="img-thumbnail"> -->
                                        <!-- <img class="img-circle elevation-2" style="width:32px" src="{{asset('avatar/default.png')}}" alt="default"> -->
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="card-footer ml-auto mr-auto">
                            <a class="btn btn-danger float-right" href="{{route('user.index')}}">Volver a la lista</a>
                            <button type="submit" class="btn btn-primary">Guardar</button>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/users/modal.blade.php
<div class="modal fade modal-slide-in-right" id="modal-delete-{{$u->id}}" tabindex="-1" role="dialog" aria-hidden="true">
	<div class="modal-dialog">
		<div class="modal-content">
			<div class="modal-header">
				@if(empty($u->deleted_at))
				<h5 class="modal-title">Bloquear usuario</h5>
				@else
				<h5 class="modal-title">Activar usuario</h5>
				@endif
				<button type="button" class="close" data-dismiss="modal" aria-label="Close">
					<span aria-hidden="true">×</span>
				</button>
			</div>
			<div class="modal-body">
				<p>{{empty($u->deleted_at) ? 'Al bloquear el usuario no podra acceder al sistema' : 'Al activar el usuario podra acceder al sistema'}}</p>
				<p>Desea continuar ?</p>
			</div>
			<div class="modal-footer">
				{{Form::Open(array('action'=>array('App\Http\Controllers\UserController@destroy',$u->id),'method'=>'delete'))}}
				<button type="button" class="btn btn-secondary" data-dismiss="modal">Cerrar</button>
				@if(empty($u->deleted_at))
				<button type="submit" class="btn btn-danger">Bloquear</button>
				@else
				<button type="submit" class="btn btn-success">Activar</button>
				@endif
				{{Form::Close()}}
			</div>
		</div>
	</div>
</div>

resources/views/users/search.blade.php
{!! Form::open(array('url'=>'user','method'=>'GET','autocomple'=>'of','role'=>'search')) !!}
<div class="form-group row">
	<div class="col-md-12">
		<div class="input-group">	
            <input class="form-control" name="searchText" id="input-search" type="text" placeholder="Buscar usuario..." value="{{$searchText}}" />			
			<button type="submit" class="btn btn-primary btn-sm">
                <i class="material-icons">search</i>
            </button>
		</div>
	</div>
</div>
{!! Form::close() !!}